// draft_list.cpp -Contains functions for the draft_list class.

// Name: 			Lawrence Bush
// RCS Account:		bushl2
// Student Number:	074640477
// Section: 		1
// Email: 			Lawrence_Bush@dps.state.ny.us

// Project 4
// _________________________________________ 
#include <iostream>
#include <iomanip>



#include "draft_list.h"
using namespace std;

const std::string NULL_STRING = "";

// This is a class function object.
// It is a class that contains one function operator().
// The function operator() sorts two players based on player salary
// information accessed from the player objects. 
// The player objects are typically passed in by a sort function 
// which uses this function object as its comparitor.
// The function object returns 1 if the expression is true and  0 if it is false.
class Greater_Salary {
public:
	
	bool operator()( player lft, player rgt )
	{
		return lft.get_salary() > rgt.get_salary();
	}
};
// This is a class function object.
// It is a class that contains one function operator().
// The function operator() sorts two players based on player value
// information accessed from the player objects. 
// The player objects are typically passed in by a sort function 
// which uses this function object as its comparitor.
// The function object returns 1 if the expression is true and  0 if it is false.
class Greater_Value {
public:
	
	bool operator()( player lft, player rgt )
	{
		return lft.get_value() > rgt.get_value();
	}
};
// This is a class function object.
// It is a class that contains one function operator().
// The function operator() sorts two players based on player value
// information accessed from the player objects. 
// The player objects are typically passed in by a sort function 
// which uses this function object as its comparitor.
// The function object returns 1 if the expression is true and  0 if it is false.
class Less_Value {
public:
	
	bool operator()( player lft, player rgt )
	{
		return lft.get_value() < rgt.get_value();
	}
};
// This is a class function object.
// It is a class that contains one function operator().
// The function operator() sorts two players based on player rating
// information accessed from the player objects. 
// The player objects are typically passed in by a sort function 
// which uses this function object as its comparitor.
// The function object returns 1 if the expression is true and  0 if it is false.
class Less_Rating {
public:
	
	bool operator()( player lft, player rgt )
	{
		return lft.get_rating() < rgt.get_rating();
	}
};
// This is a class function object.
// It is a class that contains one function operator().
// The function operator() sorts two players based on player rating
// information accessed from the player objects. 
// The player objects are typically passed in by a sort function 
// which uses this function object as its comparitor.
// The function object returns 1 if the expression is true and  0 if it is false.
class Greater_Rating {
public:
	
	bool operator()( player lft, player rgt )
	{
		return lft.get_rating() > rgt.get_rating();
	}
};
// This is a class function object.
// It is a class that contains one function operator().
// The function operator() sorts two players based on player rating, value and position
// information accessed from the player objects. 
// The player objects are typically passed in by a sort function 
// which uses this function object as its comparitor.
// The function object returns 1 if the expression is true and  0 if it is false.
class C1 {
public:
	
	bool operator()( player lft, player rgt )
	{
		int pleft=0;
		int pright=0;
		int weight=45;
		int pweight = 3;
		if(lft.get_position() == 'C' ) pleft=pweight;
		if(rgt.get_position() == 'C' ) pright=pweight;
		// C1 is a criteria I developed.
		//It multiplies rating by value, with value curved by 45 (rating * (value + 45)).
		//The curve (45) puts decreases the variation in value and thereby
		//puts more emphasis on rating.  It still, however, puts significant
		//emphasis on value.  C1 also gives centers additional points in porportion
		//to their value.  This makes the algorithm more likely to include a center
		//in the team, and especially those centers who have a respectable value.
		
		return ( (lft.get_rating() +pleft) * (lft.get_value() + weight -2*pleft ) ) > ( (rgt.get_rating()+pright) * (rgt.get_value() + weight-2*pright )  );
	}
};
// default constructor
draft_list::draft_list() {}  
// print draft list container
draft_list::print() {	
	cout << "Print Draft \n";
	for( int i = 0 ; i < size() ; i++ ) {
		cout << draft_player_list[i];
	}
}
// insert a player object into the container
draft_list::insert(player trade){
	draft_player_list.push_back(trade);
}
// remove a player object from the container
draft_list::cut(){
	draft_player_list.pop_back();
}
// assessor operator, returns player k
player draft_list::operator[](int k) const
{
	return draft_player_list[k];
}
// Sort the conainer
// Based on the passed in criteria
// Note that a pointer to the levels array is also passed in.
// This is so that the vector of players could be sorted based
// on how deep into the list the backtracking goes, or how
// wide each level typically is.
// I experimented with this but the sort I left in (C1)
// which worked the best does not use this. 
void draft_list::draft_sort(string criteria, int *levels  ) {
	
	// rating
	//The rating sort, sorts the vector of players by rating.
	//Rating is the default comparison performed by the player class.
	//However, it is the less than operator.
	//The negator could also be used in conjunction with the default comparion,
	//However, for clarity and consistency, I created a function object for this purpose.
	if(criteria == "rating") {  cout <<"sort by rating";
	std::sort(draft_player_list.begin(),draft_player_list.end(),Greater_Rating());//
	}
	
	// salary
	//The salary sort, sorts the vector of players by the salary criteria.
	if(criteria == "salary") {  cout <<"sort by salary";
	std::sort(draft_player_list.begin(),draft_player_list.end(),Greater_Salary());
	}
	
	// value
	//The value sort, sorts the vector of players by the value criteria.
	if(criteria == "value") {  cout <<"sort by value";
	std::sort(draft_player_list.begin(),draft_player_list.end(),Greater_Value());
	}
	//The C1 sort, sorts the vector of players by the C1 criteria.
	//The C1 criteria also does an additional sort by value on the top 1/9 of 
	//the draft list which puts the highest value players in that part, 
	//at the top.  It then sorts the top 1/16 by rating which puts these
	//high value high rating players in order by rating.  It then sorts 
	//the last 7/8 of the list by rating which allows the players in the
	//lower part of the list to be selected in order of rating.
	if(criteria == "C1") {  cout <<"sort by C1";
	
	std::sort(draft_player_list.begin(),draft_player_list.end(),C1());//
	std::sort(draft_player_list.begin(),draft_player_list.begin()+((draft_player_list.end()-draft_player_list.begin())/9),Greater_Value());//
	std::sort(draft_player_list.begin(),draft_player_list.begin()+((draft_player_list.end()-draft_player_list.begin())/16),Greater_Rating());//
	std::sort(draft_player_list.begin()+((draft_player_list.end()-draft_player_list.begin())/8)+1,draft_player_list.end(),Greater_Rating());//
	
	}
}

