//  File:  draft_list.h

// Name: 			Lawrence Bush
// RCS Account:		bushl2
// Student Number:	074640477
// Section: 		1
// Email: 			Lawrence_Bush@dps.state.ny.us

// Project 4
// _________________________________________ 
//
//	draft_list.h -	Contains a draft_list class.
//			Stores a vector of players read in from file.
//			Performs functions on the vector such as
//			sort and accessor [].
//

#ifndef _draft_list_h_
#define _draft_list_h_
#include <string>
#include <vector>
#include <algorithm> 
#include "player.h"
using namespace std;
//

// draft_list class
// 
//			Stores a vector of players read in from file.
//			Performs functions on the vector such as
//			sort and accessor [].
//
// This is a wrapper for a vector.
// The vector stores the list of players to pick from.
// The main backtracking routine will grab a player from this 
// container/wrapper using the accessor [] operator.
// 
class draft_list {
public:
	draft_list();  // default constructor 
	
	insert(player trade); // insert a player object into the container
	cut(); // remove a player object from the container
	
	void draft_sort(string criteria, int *levels  ); // sort the conainer
	
	int size() { return draft_player_list.size(); } // returns the number of players in the container
	print();	// print container
	player operator[](int k) const;// assessor operator, returns player k
private:  
	vector<player> draft_player_list; // private vector data member
	
};


#endif
