//
//  File:  player.h
//
// Name: 			Lawrence Bush
// RCS Account:		bushl2
// Student Number:	074640477
// Section: 		1
// Email: 			Lawrence_Bush@dps.state.ny.us

// Project 4
// _________________________________________ 

//  Purpose: Declare a class to maintain a record for an NBA player.
//
//	player.h -	Contains a player class.
//			player object stores player information,
//			and performs formated output and other
//			functions on player data.

#ifndef _player_h_
#define _player_h_
#include <string>
using namespace std;
//
class player {
	
	friend std::ostream& operator << ( std::ostream& outstr,
		const player& p );
public:
	player(){};  // default constructor -- 
	// Constructor - assigns all player attributes
	player(string name_in,const char position_in,const int FT_in, const int IN_in,
		int WT_in,	float PTS_in,float REB_in,float AST_in,int REQ_SALARY_in,float RATING_in );
	
	//**********************************************************
	//**********************************************************
	// Get functions to retrieve a statistic about the player.  
	//**********************************************************
	//**********************************************************
	int get_salary() const {return REQ_SALARY;} // returns player salary
	int get_value() const {return value;} // returns player value 
	float get_rating() const {return RATING;} // returns player rating
	string get_name() const {return name;} // returns player name
	char get_position() const {return position;} // returns player position 
	int get_FT() const {return FT;} // returns player height -ft
	int get_IN() const {return IN;} // returns player height -in
	int get_WT() const {return WT;} // returns player weight
	float get_PTS() const {return PTS;} // returns player points
	float get_REB() const {return REB;} // returns player rebounds
	float get_AST() const {return AST;} // returns player assists
	//**********************************************************
	// Overloaded < operator	
	//**********************************************************
	// Compares left<right player based on rating
	// returns 1 if left player rating is les than right player rating 
	// or 0 if not
	bool operator<( const player & rhs) const {return RATING < rhs.RATING;} 
	
private:
	//*********************************
	//*********************************
	//		Private Data Members  
	//*********************************
	//*********************************
	string name; // stores player name in string object
	char position;// stores player position in char
	int FT;// stores player height/ft in int
	int IN;// stores player height/in in int
	int WT;// stores player  in int
	float PTS;// stores player points in float
	float REB;// stores player rebounds in float
	float AST;// stores player assists in float
	int REQ_SALARY;// stores player salary requirement in int
	float RATING;// stores player rating in float
	unsigned long value;	//value = rating points per million $
	
};

#endif



